package com.borland.primetime.util.runner;

import com.borland.primetime.util.Platform;
import java.io.*;
import java.util.*;

// Referenced classes of package com.borland.primetime.util.runner:
//            Runner

public class ModifiedShellRunner extends Runner {

    private String b;
    private String a;

    public static void main(String args[]) {
        ModifiedShellRunner shellrunner = new ModifiedShellRunner();
        for(int i = 0; i < args.length; i++) {
            System.out.println("Executing ".concat(String.valueOf(String.valueOf(args[i]))));
            shellrunner.run(args[i]);
            String s = new String(shellrunner.getRawStdout());
            System.out.println("StdOut: ");
            System.out.println(s);
            String s1 = new String(shellrunner.getRawStderr());
            System.out.println("StdErr: ");
            System.out.println(s1);
            System.out.println("ExitCode: ".concat(String.valueOf(String.valueOf(shellrunner.getExitCode()))));
        }

    }

    public int getExitCode() {
        if(a.indexOf("command") != -1) {
            File file = new File(String.valueOf(String.valueOf((new StringBuffer(String.valueOf(String.valueOf(System.getProperties().getProperty("user.home"))))).append(File.separator).append("error.txt"))));
            return !file.exists() ? 0 : -1;
        } else {
            return exitCode;
        }
    }

    protected String createShellScript(String as[]) {
        if(!Platform.UNIX && !Platform.WIN32)
            return null;
        String s = "cvscmd".concat(String.valueOf(String.valueOf(Platform.WIN32 ? ".bat" : "")));
        try {
            File file = new File(String.valueOf(String.valueOf((new StringBuffer(String.valueOf(String.valueOf(System.getProperties().getProperty("user.home"))))).append(File.separator).append(s))));
            OutputStreamWriter outputstreamwriter;
            if(Platform.WIN32) {
                Locale locale = Locale.getDefault();
                if(locale.getLanguage().equalsIgnoreCase("en") && !locale.getCountry().equalsIgnoreCase("uk"))
                    outputstreamwriter = new OutputStreamWriter(new FileOutputStream(file), "Cp437");
                else
                    outputstreamwriter = new OutputStreamWriter(new FileOutputStream(file), "Cp850");
            } else {
                outputstreamwriter = new OutputStreamWriter(new FileOutputStream(file));
            }
            PrintWriter printwriter = new PrintWriter(outputstreamwriter);
            if(Platform.UNIX)
                printwriter.println("#!/bin/sh");
            else
            if(Platform.WIN32)
                printwriter.println("@echo off");
            for(Iterator iterator = runEnvironment.keySet().iterator(); iterator.hasNext();) {
                String s2 = (String)iterator.next();
                String s4 = (String)runEnvironment.get(s2);
                String s5 = String.valueOf(String.valueOf((new StringBuffer(String.valueOf(String.valueOf(s2)))).append("=").append((String)runEnvironment.get(s2))));
                if(Platform.WIN32) {
                    printwriter.println("set ".concat(String.valueOf(String.valueOf(s5))));
                } else {
                    printwriter.println(s5);
                    printwriter.println("export ".concat(String.valueOf(String.valueOf(s2))));
                }
            }

            if(runDir != null) {
                if(Platform.WIN32)
                    printwriter.println(runDir.getAbsolutePath().substring(0, 2));
                printwriter.println(String.valueOf(String.valueOf((new StringBuffer("cd \"")).append(runDir.getAbsolutePath()).append("\""))));
            }
            for(int i = 0; i < as.length; i++)
                printwriter.println(as[i]);

            if(a.indexOf("command") != -1) {
                File file1 = new File(String.valueOf(String.valueOf((new StringBuffer(String.valueOf(String.valueOf(System.getProperties().getProperty("user.home"))))).append(File.separator).append("error.txt"))));
                if(file1.exists())
                    file1.delete();
                printwriter.println("if ERRORLEVEL 1 GOTO failure");
                printwriter.println("goto end");
                printwriter.println(":failure");
                printwriter.println(String.valueOf(String.valueOf((new StringBuffer("echo \"Error Occurred\" > \"")).append(file1.getCanonicalPath()).append("\""))));
                printwriter.println(":end");
            }
            printwriter.close();
            String s3 = file.toString();
            return s3;
        }
        catch(IOException ioexception) {
            ioexception.printStackTrace();
        }
        String s1 = null;
        return s1;
    }

    public void run(String s) {
        if(runDir != null || !runEnvironment.isEmpty()) {
            f = s;
            s = createShellScript(new String[] {
                s
            });
            if(s == null)
                return;
        }
        executeCommand(String.valueOf(String.valueOf((new StringBuffer(String.valueOf(String.valueOf(a)))).append(" \"").append(s).append("\""))));
    }

    public void run(String as[]) {
        if(as == null)
            return;
        String s = createShellScript(as);
        if(Platform.WIN32)
            s = String.valueOf(String.valueOf((new StringBuffer("\"")).append(s).append("\"")));
        executeCommand(String.valueOf(String.valueOf((new StringBuffer(String.valueOf(String.valueOf(a)))).append(" ").append(s))));
    }

    private void d() {
        if(Platform.UNIX)
            a = "/bin/sh";
        else
        if(Platform.WIN32)
            if(Platform.OS_NAME.indexOf("nt") != -1)
                a = "cmd /c";
            else
            if(Platform.OS_NAME.indexOf("2000") != -1)
                a = "cmd /c";
            else
                a = "command.com /E:4096 /C";
    }

    public String getShell() {
        return a;
    }

    public void setShell(String s) {
        a = s;
    }

    private void c() {
        b = System.getProperties().getProperty("os.name").toLowerCase();
    }

    public ModifiedShellRunner(String s) {
        c();
        a = s;
    }

    public ModifiedShellRunner() {
        c();
        d();
    }

    public void run(String s, boolean addQuotesAroundCommand) {
        this.run(s);
    }

    public void run(String as[], boolean addQuotesAroundCommand) {
        this.run(as);
    }
}
