package com.deviousbard.ssvcs;

import javax.swing.*;
import java.awt.*;

public class ActionComboBoxRenderer extends JLabel implements ListCellRenderer {

    public static final int ICON_ADD = 0;
    public static final int ICON_GET = 1;
    public static final int ICON_CHECKIN = 2;
    public static final int ICON_CHECKOUT = 3;
    public static final int ICON_UNDO_CHECKOUT = 4;
    public static final int ICON_NO_ACTION = 5;

    ImageIcon images[];

    public ActionComboBoxRenderer() {
        setOpaque(true);
        setHorizontalAlignment(LEFT);
        setVerticalAlignment(CENTER);
        images = new ImageIcon[6];
        images[ICON_ADD] = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/add.gif"));
        images[ICON_ADD].setDescription("Add");
        images[ICON_GET] = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/get.gif"));
        images[ICON_GET].setDescription("Get");
        images[ICON_CHECKIN] = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/checkin.gif"));
        images[ICON_CHECKIN].setDescription("Checkin");
        images[ICON_CHECKOUT] = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/checkout.gif"));
        images[ICON_CHECKOUT].setDescription("Checkout");
        images[ICON_UNDO_CHECKOUT] = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/undochko.gif"));
        images[ICON_UNDO_CHECKOUT].setDescription("Undo Checkout");
        images[ICON_NO_ACTION] = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/noaction.gif"));
        images[ICON_NO_ACTION].setDescription("No Action");
    }

    public Component getListCellRendererComponent(
                                       JList list,
                                       Object value,
                                       int index,
                                       boolean isSelected,
                                       boolean cellHasFocus) {
        if (isSelected) {
            setBackground(list.getSelectionBackground());
            setForeground(list.getSelectionForeground());
        } else {
            setBackground(list.getBackground());
            setForeground(list.getForeground());
        }

        String text = (String) value;
        if (text != null) {
            int action = -1;
            if (text.equalsIgnoreCase("add"))
                action = ICON_ADD;
            if (text.equalsIgnoreCase("get"))
                action = ICON_GET;
            if (text.equalsIgnoreCase("checkin"))
                action = ICON_CHECKIN;
            if (text.equalsIgnoreCase("checkout"))
                action = ICON_CHECKOUT;
            if (text.equalsIgnoreCase("undo checkout"))
                action = ICON_UNDO_CHECKOUT;
            if (text.equalsIgnoreCase("no action"))
                action = ICON_NO_ACTION;
            ImageIcon icon = images[action];
            setText(icon.getDescription());
            setIcon(icon);
            return this;
        }
        return new JLabel();
    }
}
