package com.deviousbard.ssvcs;

import java.awt.event.*;
import javax.swing.*;
import com.borland.primetime.ide.*;
import com.borland.primetime.node.*;
import com.borland.primetime.actions.*;
import com.borland.primetime.teamdev.vcs.*;
import com.borland.primetime.util.*;
import com.borland.jbuilder.node.JBProject;
import java.io.*;
import com.deviousbard.opentool.util.*;


public class Actions {

  private static int savedStatus = 0;
  public static final Icon ADD_ICON = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/add.gif"));
  public static final Icon ADD_CHECK_ICON = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/add-check.gif"));
  public static final Icon GET_ICON = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/get.gif"));
  public static final Icon GET_CHECK_ICON = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/get-check.gif"));
  public static final Icon CHECKOUT_ICON = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/checkout.gif"));
  public static final Icon CHECKOUT_CHECK_ICON = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/checkout-check.gif"));
  public static final Icon CHECKIN_ICON = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/checkin.gif"));
  public static final Icon CHECKIN_CHECK_ICON = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/checkin-check.gif"));
  public static final Icon UNDO_CHECKOUT_ICON = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/undochko.gif"));
  public static final Icon UNDO_CHECKOUT_CHECK_ICON = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/undochko-check.gif"));
  public static final Icon STATUS_ICON = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/status.gif"));
  public static final Icon MULTI_FILE_ICON = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/multfile.gif"));
  public static final Icon CREATE_PROJECT_ICON = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/create-project.gif"));
  public static final Icon GET_PROJECT_ICON = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/get-project.gif"));

  public Actions() {
  }


  public static UpdateAction ADD = new UpdateAction("Add",'A',"Add file into Microsoft Source Safe", Actions.ADD_ICON) {
    public void update( Object source ) {
      Node[] nodeList = Browser.getActiveBrowser().getProjectView().getSelectedNodes();
      savedStatus = SourceSafeVCSUtils.getStatus();
      setEnabled((SourceSafeVCSStatus.isNewFile(savedStatus)) && (nodeList.length == 1));
    }

    public void actionPerformed( ActionEvent e ) {
      Node[] nodeList = Browser.getActiveBrowser().getProjectView().getSelectedNodes();
      SourceSafeVCS vcs = (SourceSafeVCS)VCSFactory.getVCS("SourceSafeVCS");
      String msg = "FIX ME!";
      vcs.add(nodeList, msg);
    }
  };

  public static UpdateAction ADD_FILE = new UpdateAction("Add",'A',"Add file into Microsoft Source Safe", Actions.ADD_ICON) {
    public void update( Object source ) {
      FileNode activeNode = VCSUtils.getBrowserActiveNode();
      String fileName = "";
      boolean enabled = false;
      if (activeNode != null) {
        savedStatus = SourceSafeVCSUtils.getStatus(activeNode.getUrl().getFileObject(), (JBProject)Browser.getActiveBrowser().getActiveProject());
        fileName = activeNode.getDisplayName();
        enabled = SourceSafeVCSStatus.isNewFile(savedStatus);
      }
      setShortText("Add" + (fileName.equals("") ? "" : " \"" + fileName + "\""));
      setEnabled(enabled);
    }

    public void actionPerformed( ActionEvent e ) {
      Node[] nodeList = new Node[1];
      nodeList[0] = VCSUtils.getBrowserActiveNode();
      SourceSafeVCS vcs = (SourceSafeVCS)VCSFactory.getVCS("SourceSafeVCS");
      String msg = "FIX ME!";
      vcs.add(nodeList, msg);
    }
  };

  /** @todo Add dialog to retreieve comment string from the user */
  public static UpdateAction CHECKIN = new UpdateAction("Checkin",'i',"Check file into Microsoft Source Safe", Actions.CHECKIN_ICON) {
    public void update( Object source ) {
      Node[] nodeList = Browser.getActiveBrowser().getProjectView().getSelectedNodes();
      setEnabled((SourceSafeVCSStatus.isCheckedOutByThisUser(savedStatus)) && (nodeList.length == 1));
    }

    public void actionPerformed( ActionEvent e ) {
      Node[] nodeList = Browser.getActiveBrowser().getProjectView().getSelectedNodes();
      SourceSafeVCS vcs = (SourceSafeVCS)VCSFactory.getVCS("SourceSafeVCS");
      String msg = "FIX ME !";
      vcs.checkin(nodeList, msg );
    }
  };

  public static UpdateAction CHECKIN_FILE = new UpdateAction("Checkin",'i',"Check file into Microsoft Source Safe", Actions.CHECKIN_ICON) {
    public void update( Object source ) {
      FileNode activeNode = VCSUtils.getBrowserActiveNode();
      String fileName = "";
      boolean enabled = false;
      if (activeNode != null) {
        fileName = activeNode.getDisplayName();
        enabled = SourceSafeVCSStatus.isCheckedOutByThisUser(savedStatus);
      }
      setShortText("Checkin" + (fileName.equals("") ? "" : " \"" + fileName + "\""));
      setEnabled(enabled);
    }

    public void actionPerformed( ActionEvent e ) {
      Node[] nodeList = new Node[1];
      nodeList[0] = VCSUtils.getBrowserActiveNode();
      SourceSafeVCS vcs = (SourceSafeVCS)VCSFactory.getVCS("SourceSafeVCS");
      String msg = "FIX ME !";
      vcs.checkin(nodeList, msg );
    }
  };

  public static UpdateAction UNDO_CHECKOUT = new UpdateAction("Undo Checkout",'u',"Undo checkout from Microsoft Source Safe", Actions.UNDO_CHECKOUT_ICON) {
    public void update( Object source ) {
      Node[] nodeList = Browser.getActiveBrowser().getProjectView().getSelectedNodes();
      setEnabled((SourceSafeVCSStatus.isCheckedOutByThisUser(savedStatus)) && (nodeList.length == 1));
    }

    public void actionPerformed( ActionEvent e ) {
      Node[] nodeList = Browser.getActiveBrowser().getProjectView().getSelectedNodes();
      SourceSafeVCS vcs = (SourceSafeVCS)VCSFactory.getVCS("SourceSafeVCS");
      String msg = "FIX ME !";
      vcs.undoCheckout(nodeList, msg );
    }
  };

  public static UpdateAction UNDO_CHECKOUT_FILE = new UpdateAction("Undo Checkout",'u',"Undo checkout from Microsoft Source Safe", Actions.UNDO_CHECKOUT_ICON) {
    public void update( Object source ) {
      FileNode activeNode = VCSUtils.getBrowserActiveNode();
      String fileName = "";
      boolean enabled = false;
      if (activeNode != null) {
        fileName = activeNode.getDisplayName();
        enabled = SourceSafeVCSStatus.isCheckedOutByThisUser(savedStatus);
      }
      setShortText("Undo Checkout" + (fileName.equals("") ? "" : " \"" + fileName + "\""));
      setEnabled(enabled);
    }

    public void actionPerformed( ActionEvent e ) {
      Node[] nodeList = new Node[1];
      nodeList[0] = VCSUtils.getBrowserActiveNode();
      SourceSafeVCS vcs = (SourceSafeVCS)VCSFactory.getVCS("SourceSafeVCS");
      String msg = "FIX ME !";
      vcs.undoCheckout(nodeList, msg );
    }
  };

  public static UpdateAction CHECKOUT = new UpdateAction("Checkout",'o',"Check file out of Microsoft Source Safe", Actions.CHECKOUT_ICON) {
    public void update( Object source ) {
      Node[] nodeList = Browser.getActiveBrowser().getProjectView().getSelectedNodes();
      setEnabled((SourceSafeVCSStatus.isAvailable(savedStatus) || SourceSafeVCSStatus.isCheckedOutByAnotherUser(savedStatus))  && (! SourceSafeVCSStatus.isCheckedOutByThisUser(savedStatus)) && (nodeList.length == 1));
    }

    public void actionPerformed( ActionEvent e ) {
      Node[] nodeList = Browser.getActiveBrowser().getProjectView().getSelectedNodes();
      SourceSafeVCS vcs = (SourceSafeVCS)VCSFactory.getVCS("SourceSafeVCS");
      String msg = "FIX ME !";
      vcs.checkout(nodeList, msg );
    }
  };

  public static UpdateAction CHECKOUT_FILE = new UpdateAction("Checkout",'o',"Check file out of Microsoft Source Safe", Actions.CHECKOUT_ICON) {
    public void update( Object source ) {
      FileNode activeNode = VCSUtils.getBrowserActiveNode();
      String fileName = "";
      boolean enabled = false;
      if (activeNode != null) {
        fileName = activeNode.getDisplayName();
        enabled = (SourceSafeVCSStatus.isAvailable(savedStatus) || SourceSafeVCSStatus.isCheckedOutByAnotherUser(savedStatus)) && (! SourceSafeVCSStatus.isCheckedOutByThisUser(savedStatus));
      }
      setShortText("Checkout" + (fileName.equals("") ? "" : " \"" + fileName + "\""));
      setEnabled(enabled);
    }

    public void actionPerformed( ActionEvent e ) {
      Node[] nodeList = new Node[1];
      nodeList[0] = VCSUtils.getBrowserActiveNode();
      SourceSafeVCS vcs = (SourceSafeVCS)VCSFactory.getVCS("SourceSafeVCS");
      String msg = "FIX ME !";
      vcs.checkout(nodeList, msg );
    }
  };

  public static UpdateAction GET = new UpdateAction("Get",'G',"Get file out of Microsoft Source Safe", Actions.GET_ICON) {
    public void update( Object source ) {
      Node[] nodeList = Browser.getActiveBrowser().getProjectView().getSelectedNodes();
      setEnabled((SourceSafeVCSStatus.isAvailable(savedStatus) || SourceSafeVCSStatus.isCheckedOutByAnotherUser(savedStatus) || SourceSafeVCSStatus.isCheckedOutByThisUser(savedStatus)) && (nodeList.length == 1));
    }

    public void actionPerformed( ActionEvent e ) {
      Node[] nodeList = Browser.getActiveBrowser().getProjectView().getSelectedNodes();
      SourceSafeVCS vcs = (SourceSafeVCS)VCSFactory.getVCS("SourceSafeVCS");
      String msg = "FIX ME !";
      vcs.get(nodeList, msg );
    }
  };

  public static UpdateAction GET_FILE = new UpdateAction("Get",'G',"Get file out of Microsoft Source Safe", Actions.GET_ICON) {
    public void update( Object source ) {
      FileNode activeNode = VCSUtils.getBrowserActiveNode();
      String fileName = "";
      boolean enabled = false;
      if (activeNode != null) {
        fileName = activeNode.getDisplayName();
        enabled = SourceSafeVCSStatus.isAvailable(savedStatus) || SourceSafeVCSStatus.isCheckedOutByAnotherUser(savedStatus) || SourceSafeVCSStatus.isCheckedOutByThisUser(savedStatus);
      }
      setShortText("Get" + (fileName.equals("") ? "" : " \"" + fileName + "\""));
      setEnabled(enabled);
    }

    public void actionPerformed( ActionEvent e ) {
      Node[] nodeList = new Node[1];
      nodeList[0] = VCSUtils.getBrowserActiveNode();
      SourceSafeVCS vcs = (SourceSafeVCS)VCSFactory.getVCS("SourceSafeVCS");
      String msg = "FIX ME !";
      vcs.get(nodeList, msg );
    }
  };

  public static UpdateAction STATUS = new UpdateAction("Status",'S',"Check file status in Microsoft Source Safe", Actions.STATUS_ICON) {
    public void update( Object source ) {
      Node[] nodeList = Browser.getActiveBrowser().getProjectView().getSelectedNodes();
      setEnabled(nodeList.length == 1);
    }

    public void actionPerformed( ActionEvent e ) {
      Node[] nodeList = Browser.getActiveBrowser().getProjectView().getSelectedNodes();
      SourceSafeVCS vcs = (SourceSafeVCS)VCSFactory.getVCS("SourceSafeVCS");
      String msg = "FIX ME !";
      vcs.status(nodeList, msg );
    }
  };

  public static UpdateAction STATUS_FILE = new UpdateAction("Status",'S',"Check file status in Microsoft Source Safe", Actions.STATUS_ICON) {
    public void update( Object source ) {
      FileNode activeNode = VCSUtils.getBrowserActiveNode();
      String fileName = "";
      boolean enabled = false;
      if (activeNode != null) {
        fileName = activeNode.getDisplayName();
        enabled = true;
      }
      setShortText("Status" + (fileName.equals("") ? "" : " \"" + fileName + "\""));
      setEnabled(enabled);
    }

    public void actionPerformed( ActionEvent e ) {
      Node[] nodeList = new Node[1];
      nodeList[0] = VCSUtils.getBrowserActiveNode();
      SourceSafeVCS vcs = (SourceSafeVCS)VCSFactory.getVCS("SourceSafeVCS");
      String msg = "FIX ME !";
      vcs.status(nodeList, msg );
    }
  };

  public static UpdateAction MULTI_FILE = new UpdateAction("Multiple File Actions...",'M',"Perform actions on multiple Microsoft Source Safe files", Actions.MULTI_FILE_ICON) {
    public void update( Object source ) {
      Node[] nodeList = Browser.getActiveBrowser().getProjectView().getSelectedNodes();
      setEnabled(nodeList.length > 1);
    }

    public void actionPerformed( ActionEvent e ) {
      Node[] nodeList = Browser.getActiveBrowser().getProjectView().getSelectedNodes();
      String msg = "FIX ME !";
      SourceSafeVCS vcs = (SourceSafeVCS)VCSFactory.getVCS("SourceSafeVCS");
      vcs.multiFileActions(nodeList, msg);
    }
  };

  public static UpdateAction CREATE_PROJECT = new UpdateAction("Create project folder...",'C',"Create a new project in Microsoft Source Safe", Actions.CREATE_PROJECT_ICON) {
    public void update( Object source ) {
      setEnabled(true);
    }

    public void actionPerformed( ActionEvent e ) {
      String msg = "FIX ME !";
      SourceSafeVCS vcs = (SourceSafeVCS)VCSFactory.getVCS("SourceSafeVCS");
      vcs.createProject(msg);
    }
  };

  public static UpdateAction GET_PROJECT = new UpdateAction("Get project files...",'G',"Get project files in Microsoft Source Safe", Actions.GET_PROJECT_ICON) {
    public void update( Object source ) {
      setEnabled(true);
    }

    public void actionPerformed( ActionEvent e ) {
      String msg = "FIX ME !";
      SourceSafeVCS vcs = (SourceSafeVCS)VCSFactory.getVCS("SourceSafeVCS");
      vcs.getProject(msg);
    }
  };
}
