package com.deviousbard.ssvcs;

import com.borland.primetime.teamdev.vcs.*;
import com.borland.primetime.teamdev.frontend.VCSBrowserContextActionProvider;
import com.borland.primetime.node.*;
import com.borland.primetime.ide.*;
import com.borland.primetime.vfs.Url;
import com.borland.primetime.actions.ActionGroup;
import com.borland.jbuilder.node.JBProject;

import java.util.List;
import java.util.Vector;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.*;
import com.borland.primetime.properties.*;
import com.borland.primetime.help.HelpTopic;
import java.util.*;

public class ConfigPage extends PropertyPage
{
  ConfigPanel pnlConfig = new ConfigPanel();
  JBProject project;

  public ConfigPage( JBProject project ) {
    this.project = project;
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.readProperties();
    this.add(pnlConfig);
  }

  public void writeProperties() {
    project.setAutoProperty(VCS.CATEGORY, SourceSafeVCS.SS_EXE, pnlConfig.getSourceSafeExecutable());
    project.setAutoProperty(VCS.CATEGORY, SourceSafeVCS.SS_USER, pnlConfig.getSourceSafeUserId());
    project.setAutoProperty(VCS.CATEGORY, SourceSafeVCS.SS_PASSWORD, pnlConfig.getSourceSafePassword());
    project.setAutoProperty(VCS.CATEGORY, SourceSafeVCS.SS_AUTH_REQ, pnlConfig.getAuthRequired());
    project.setAutoProperty(VCS.CATEGORY, SourceSafeVCS.SS_COMMAND_OUTPUT, pnlConfig.getCommandOutput());
    project.setAutoProperty(VCS.CATEGORY, SourceSafeVCS.SS_HIST_REV, pnlConfig.getHistoryRevisions());
    int index = 0;
    for (Iterator i=pnlConfig.getDirectoryMappings().keySet().iterator(); i.hasNext();) {
        String key = (String)i.next();
        project.setAutoProperty(VCS.CATEGORY, SourceSafeVCS.SS_MAPPINGS + "_KEY_" + index, key);
        project.setAutoProperty(VCS.CATEGORY, SourceSafeVCS.SS_MAPPINGS + "_VALUE_" + index, (String)pnlConfig.getDirectoryMappings().get(key));
        index++;
    }
  }

  public HelpTopic getHelpTopic() {
    return null;
  }

  public void readProperties() {
    String ssExe = project.getAutoProperty(VCS.CATEGORY, SourceSafeVCS.SS_EXE);
    String ssUser = project.getAutoProperty(VCS.CATEGORY, SourceSafeVCS.SS_USER);
    String ssPass = project.getAutoProperty(VCS.CATEGORY, SourceSafeVCS.SS_PASSWORD);
    String ssAuthReq = project.getAutoProperty(VCS.CATEGORY, SourceSafeVCS.SS_AUTH_REQ);
    String ssCommandOutput = project.getAutoProperty(VCS.CATEGORY, SourceSafeVCS.SS_COMMAND_OUTPUT);
    String ssHistRev = project.getAutoProperty(VCS.CATEGORY, SourceSafeVCS.SS_HIST_REV);
    if ( ssExe != null ) {
      pnlConfig.setSourceSafeExecutable(ssExe.replace('/', '\\'));
    }
    if ( ssUser != null) {
      pnlConfig.setSourceSafeUserId(ssUser);
    }
    if (ssPass != null) {
        pnlConfig.setSourceSafePassword(ssPass);
    }
    if (ssAuthReq != null) {
        pnlConfig.setAuthRequired(ssAuthReq);
    }
    if (ssCommandOutput != null) {
        pnlConfig.setCommandOutput(ssCommandOutput);
    }
    if (ssHistRev != null) {
        pnlConfig.setHistoryRevisions(ssHistRev);
    }
    Map ssDirectoryMappings = new HashMap();
    String key = null;
    int index = 0;
    while ((key = project.getAutoProperty(VCS.CATEGORY, SourceSafeVCS.SS_MAPPINGS + "_KEY_" + index)) != null ) {
        ssDirectoryMappings.put(key, project.getAutoProperty(VCS.CATEGORY, SourceSafeVCS.SS_MAPPINGS + "_VALUE_" + index));
        index++;
    }
    pnlConfig.setDirectoryMappings(ssDirectoryMappings);
  }

  public ConfigPanel getConfigPanel() {
    return this.pnlConfig;
  }

  public Map getDirectoryMappings() {
    return this.pnlConfig.getDirectoryMappings();
  }
}
