package com.deviousbard.ssvcs;

import com.borland.primetime.actions.ActionGroup;
import com.borland.primetime.teamdev.vcs.*;
import com.borland.primetime.teamdev.frontend.*;
import javax.swing.Icon;

public class RevisionStatus extends VCSFileStatus {

    public static final int STATUS_NEW         = 0;
    public static final int STATUS_WSP_CHANGE  = 1;
    public static final int STATUS_REPO_CHANGE = 2;
    public static final int STATUS_REMOVED     = 3;

    private FileDesc[] descs = {
                               new FileDesc(VCSIcons.FILE_NEW,         "New File" ),
                               new FileDesc(VCSIcons.WORKSPACE_CHANGE, "Different From Repository"),
                               new FileDesc(VCSIcons.REPOSITORY_CHANGE,"Changed In Repository"),
                               new FileDesc(VCSIcons.FILE_REMOVED,     "Removed From Repository")
                             };
                             
    public RevisionStatus(int status) {
        this.status = status;
    }
  
    public ActionGroup getActions() {
        return null;
    }

    public Icon getStatusIcon() {
        return descs[status].icon;
    }

    public boolean isModifiedInVCS() {
        return false;
    }

    public boolean isModifiedLocally() {
        return status == STATUS_WSP_CHANGE;
    }

    public String getDescription() {
        return descs[status].desc;
    }

    private class FileDesc {
        public Icon icon;
        public String desc;
    
        public FileDesc( Icon icon, String desc ) {
            this.icon = icon; 
            this.desc = desc;
        }
    }
    
    public boolean isNew() {
        return false;
    }
}
