package com.deviousbard.ssvcs;

import javax.swing.tree.*;
import com.borland.jbcl.layout.*;
import com.borland.primetime.teamdev.vcs.*;
import com.borland.primetime.teamdev.frontend.*;
import com.borland.primetime.teamdev.runner.*;
import com.borland.primetime.properties.PropertyPage;
import com.borland.primetime.node.*;
import com.borland.primetime.ide.*;
import com.borland.primetime.vfs.Url;
import com.borland.primetime.actions.ActionGroup;
import com.borland.jbuilder.node.JBProject;
import com.borland.primetime.ui.*;
import java.util.*;
import javax.swing.*;
import java.io.*;
import com.borland.jbcl.layout.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.*;
import com.borland.jbuilder.*;
import com.borland.primetime.*;
import com.deviousbard.opentool.util.*;
import java.text.*;

public class SourceSafeProjectBrowserPanel extends JPanel {

    String sourceSafeExecutablePath = null;
    String userId = null;
    String password = null;
    boolean authRequired = false;
    JTree treeProjects = null;
    BorderLayout bdrlProjectBrowser = new BorderLayout();
    public static final Icon CREATE_PROJECT_ICON = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/create-project.gif"));
    public static final Icon GET_PROJECT_ICON = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/get-project.gif"));
    public static final Icon CLOSED_PROJECT_FOLDER_ICON = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/ss-project-close.gif"));
    public static final Icon OPEN_PROJECT_FOLDER_ICON = new ImageIcon(ClassLoader.getSystemResource("com/deviousbard/ssvcs/ss-project-open.gif"));
    CreateProjectDialog createProjectDialog;
    GetProjectDialog getProjectDialog;
    SourceSafeProjectNode selectedNode = null;
    TreePath selectedPath = null;

    public SourceSafeProjectBrowserPanel(String sourceSafeExecutablePath, String userId, String password, boolean authRequired) {
        super();
        this.sourceSafeExecutablePath = sourceSafeExecutablePath;
        this.userId = userId;
        this.password = password;
        this.authRequired = authRequired;
        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }

    public SourceSafeProjectBrowserPanel(String sourceSafeExecutablePath, String userId, String password, boolean authRequired, boolean isDoubleBuffered) {
        super(isDoubleBuffered);
        this.sourceSafeExecutablePath = sourceSafeExecutablePath;
        this.userId = userId;
        this.password = password;
        this.authRequired = authRequired;
        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }

    public SourceSafeProjectBrowserPanel(String sourceSafeExecutablePath, String userId, String password, boolean authRequired, LayoutManager layout) {
        super(layout);
        this.sourceSafeExecutablePath = sourceSafeExecutablePath;
        this.userId = userId;
        this.password = password;
        this.authRequired = authRequired;
        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }

    public SourceSafeProjectBrowserPanel(String sourceSafeExecutablePath, String userId, String password, boolean authRequired, LayoutManager layout, boolean isDoubleBuffered) {
        super(layout, isDoubleBuffered);
        this.sourceSafeExecutablePath = sourceSafeExecutablePath;
        this.userId = userId;
        this.password = password;
        this.authRequired = authRequired;
        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }

    public SourceSafeProjectBrowserPanel() {
        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        MouseListener ml = new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                //int selRow = treeProjects.getRowForLocation(e.getX(), e.getY());
                TreePath selPath = treeProjects.getPathForLocation(e.getX(), e.getY());
                //if(selRow != -1) {
                    if(e.getClickCount() == 1) {
                        if ((e.getModifiers() & e.BUTTON3_MASK) != 0) {
                            // treeSingleClick(selRow, selPath);
                            popupTreeContextMenu(selPath, e.getX(), e.getY());
                        }
                    }
                //}
            }
        };
        this.setLayout(bdrlProjectBrowser);
        treeProjects = new JTree();
        DefaultTreeCellRenderer renderer = new DefaultTreeCellRenderer();
        renderer.setOpenIcon(OPEN_PROJECT_FOLDER_ICON);
        renderer.setClosedIcon(CLOSED_PROJECT_FOLDER_ICON);
        treeProjects.setCellRenderer(renderer);
        treeProjects.addMouseListener(ml);
        this.refreshTreeProjects();
        this.add(new JScrollPane(treeProjects), BorderLayout.CENTER);

        createProjectDialog = new CreateProjectDialog(new Frame(), "Create Project", true);
        createProjectDialog.setSize(405, 330);
        createProjectDialog.btnOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                createProject_btnOK_actionPerformed(e);
            }
        });
        createProjectDialog.btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                createProject_btnCancel_actionPerformed(e);
            }
        });

        getProjectDialog = new GetProjectDialog(new Frame(), "Get Project", true);
        getProjectDialog.setSize(405, 330);
        getProjectDialog.btnOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                getProject_btnOK_actionPerformed(e);
            }
        });
        getProjectDialog.btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                getProject_btnCancel_actionPerformed(e);
            }
        });
    }

    public String getSelectedProject() {
        return ((SourceSafeProjectNode)treeProjects.getSelectionPath().getLastPathComponent()).getAbsoluteProject();
    }

    public void refreshTreeProjects() {
        treeProjects.setModel(new DefaultTreeModel(new SourceSafeProjectNode("", sourceSafeExecutablePath, this.userId, this.password, this.authRequired)));
    }

    public void refreshTreeProjects(SourceSafeProjectNode node, String newSubProject) {
        if (treeProjects.isExpanded(this.selectedPath)) {
            SourceSafeProjectNode childNode = new SourceSafeProjectNode(newSubProject, sourceSafeExecutablePath, this.userId, this.password, this.authRequired);
            ((DefaultTreeModel)treeProjects.getModel()).insertNodeInto(childNode, node, 0);
        } else {
            treeProjects.expandPath(this.selectedPath);
        }
        treeProjects.updateUI();
    }

    public void popupTreeContextMenu(TreePath selPath, int x, int y) {
        this.selectedPath = selPath;
        this.selectedNode = (SourceSafeProjectNode)selPath.getLastPathComponent();
        final String selectedProject = ((SourceSafeProjectNode)selPath.getLastPathComponent()).getAbsoluteProject();
        final JPopupMenu menu = new JPopupMenu();
        Action createSubProjectAction = new AbstractAction("Create sub-project...", CREATE_PROJECT_ICON) {
            public void actionPerformed(ActionEvent e) {
                displayCreateProjectDialog(menu, selectedProject);
            }
        };
        Action getProjectAction = new AbstractAction("Get project files...", GET_PROJECT_ICON) {
            public void actionPerformed(ActionEvent e) {
                displayGetProjectDialog(menu, selectedProject);
            }
        };
        menu.add(createSubProjectAction);
        menu.add(getProjectAction);
        menu.show(treeProjects, x, y);
    }

    public void displayCreateProjectDialog(JPopupMenu menu, String selectedProject) {
        SourceSafeVCS vcs = (SourceSafeVCS)VCSFactory.getVCS("SourceSafeVCS");
        createProjectDialog.reset();
        createProjectDialog.setParentProject(this.selectedNode.getAbsoluteProject());
        createProjectDialog.setVisible(true);
    }

    public void createProject_btnOK_actionPerformed(ActionEvent e) {
        this.createProjectDialog.setVisible(false);
        String parentProject = createProjectDialog.getParentProject();
        String newSubProject = createProjectDialog.getNewSubProject();
        String comment = createProjectDialog.getComment();
        this.selectedNode.createProject(parentProject, newSubProject, comment);
        this.refreshTreeProjects(this.selectedNode, newSubProject);
    }

    public void createProject_btnCancel_actionPerformed(ActionEvent e) {
        this.createProjectDialog.setVisible(false);
    }

    public void displayGetProjectDialog(JPopupMenu menu, String selectedProject) {
        String projectName = (selectedProject.lastIndexOf('/') != -1 ? selectedProject.substring(selectedProject.lastIndexOf('/') + 1) : selectedProject); 
        getProjectDialog.setSelectedProject(selectedProject);
        getProjectDialog.setTitle("Get " + projectName);
        getProjectDialog.reset();
        getProjectDialog.setVisible(true);
    }

    public void getProject_btnOK_actionPerformed(ActionEvent e) {
        SourceSafeVCS vcs = (SourceSafeVCS)VCSFactory.getVCS("SourceSafeVCS");
        String makeWritableOption = "";
        String commandOption = " Get ";
        String recursiveOption = "";
        String commentOption = "";
        if (this.getProjectDialog.isMakeWritableSelected()) {
            makeWritableOption = " -W ";
        }
        if (this.getProjectDialog.isCheckoutSelected()) {
            commandOption = " Checkout ";
            commentOption = (this.getProjectDialog.getComment() == null || this.getProjectDialog.getComment().equals("") ? "" : " -C\"" + this.getProjectDialog.getComment() + "\" ");
        }
        if (this.getProjectDialog.isRecursiveSelected()) {
            recursiveOption = " -R ";
        } 

        JBProject prj = (JBProject)Browser.getActiveBrowser().getActiveProject();
        String ssExe = prj.getAutoProperty(VCS.CATEGORY, SourceSafeVCS.SS_EXE);
        String ssUser = prj.getAutoProperty(VCS.CATEGORY, SourceSafeVCS.SS_USER);
        String ssPass = prj.getAutoProperty(VCS.CATEGORY, SourceSafeVCS.SS_PASSWORD);
        String ssAuthRequired = prj.getAutoProperty(VCS.CATEGORY, SourceSafeVCS.SS_AUTH_REQ);
        String auth="";
        if (ssAuthRequired.equals("TRUE")) {
            auth = " -Y" + ssUser + "," + ssPass + " ";
        }
        Map directoryMappings = ((ConfigPage)vcs.getProjectConfigPage(prj)).getDirectoryMappings();
        String dirPath = getMappedDirectory(directoryMappings, this.getProjectDialog.getSelectedProject());
        if (dirPath == null) {
            SourceSafeVCSUtils.showMessage("This project is not mapped to a local directory in JBuilder.  It must be mapped from the \"Configure Version Control\" menu.", "Unmapped Project", JOptionPane.ERROR_MESSAGE);        
        } else {
            int commandCount = 3;
            String[] commands = new String[commandCount];
            String drive = dirPath.substring(0,2);
            commands[0] = drive;
            commands[1] = "cd " + "\"" + dirPath.substring(2).replace('/', File.separator.charAt(0)) + "\"";
            commands[2] = "\"" + ssExe + "\"" + commandOption + "\"" + this.getProjectDialog.getSelectedProject() + "\" -I-Y -GWR" + makeWritableOption + recursiveOption + auth + commentOption;
            SourceSafeVCSUtils.runCommands(commands, "Get Project", true);
        }
        this.getProjectDialog.setVisible(false);
    }

    public void getProject_btnCancel_actionPerformed(ActionEvent e) {
        this.getProjectDialog.setVisible(false);
    }
    
    private String getMappedDirectory(Map directoryMappings, String project) {
        String dirPath = null;
        int dirPathLen = 0;
        SourceSafeVCS vcs = (SourceSafeVCS)VCSFactory.getVCS("SourceSafeVCS");
        for (Iterator i = directoryMappings.keySet().iterator(); i.hasNext();) {
            String dir = (String)i.next();
            String mappedProject = (String)directoryMappings.get(dir); 
            if (project.indexOf(mappedProject) != -1) {
                if (mappedProject.length() == project.length()) {
                    return dir;
                } else {
                    if (dirPathLen < dir.length()) {
                        dirPathLen = dir.length();
                        dirPath = dir;
                    }
                }
            }
        }
        return dirPath;
    }
}
