package com.deviousbard.ssvcs;

public class SourceSafeVCSStatus {
    
    public static final int CHECKED_OUT_BY_THIS_USER = 1;
    public static final int CHECKED_OUT_BY_ANOTHER_USER = 2;
    public static final int DIFFERENT_FROM_WORKFILE = 4;
    public static final int NEW_FILE = 8;
    public static final int AVAILABLE = 16;

    public SourceSafeVCSStatus() {
    }
    
    public static boolean isCheckedOutByThisUser(int status) {
        return ((status&CHECKED_OUT_BY_THIS_USER) != 0);
    }

    public static boolean isCheckedOutByAnotherUser(int status) {
        return ((status&CHECKED_OUT_BY_ANOTHER_USER) != 0);
    }
        
    public static boolean isDifferentFromWorkFile(int status) {
        return ((status&DIFFERENT_FROM_WORKFILE) != 0);
    }

    public static boolean isNewFile(int status) {
        return ((status&NEW_FILE) != 0);
    }

    public static boolean isAvailable(int status) {
        return ((status&AVAILABLE) != 0);
    }
}
