package com.deviousbard.ssvcs;

import javax.swing.*;
import java.awt.*;
import com.borland.jbcl.layout.*;
import javax.swing.border.*;
import java.awt.event.*;
import com.borland.primetime.teamdev.vcs.*;

public class WorkFileMappingDialog extends JDialog {
    JPanel pnlProject = new JPanel();
    XYLayout xYLayout1 = new XYLayout();
    BorderLayout borderLayout1 = new BorderLayout();
    JPanel pnlWorkFile = new JPanel();
    JButton btnMap = new JButton();
    BorderLayout borderLayout2 = new BorderLayout();

    SourceSafeVCS vcs = (SourceSafeVCS)VCSFactory.getVCS("SourceSafeVCS");

    String projectName = null;
    String workingDirName = null;

    String ssExe = null;
    String userId = null;
    String password = null;
    boolean authRequired = false;
    JButton btnCancel = new JButton();
    JLabel lblInstructions = new JLabel();
    JScrollPane scrollPaneSourceSafeProject = new JScrollPane();
    JScrollPane scrollPaneWorkingDirectory = new JScrollPane();
    SourceSafeProjectBrowserPanel pnlProjectBrowser = null;
    DirectoryBrowserPanel pnlDirectoryBrowser = null;
    JPanel jPanel2 = new JPanel();

    public WorkFileMappingDialog() {
        super();
        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace(vcs.log);
        }
    }

    public WorkFileMappingDialog(String ssExe, String userId, String password, String authRequired) {
        super();
        this.ssExe = ssExe;
        this.userId = userId;
        this.password = password;
        this.authRequired = (new Boolean(authRequired)).booleanValue();
        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace(vcs.log);
        }
    }

    public WorkFileMappingDialog(String ssExe, String userId, String password, String authRequired, Dialog owner) {
        super(owner);
        this.ssExe = ssExe;
        this.userId = userId;
        this.password = password;
        this.authRequired = (new Boolean(authRequired)).booleanValue();
        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace(vcs.log);
        }
    }

    public WorkFileMappingDialog(String ssExe, String userId, String password, String authRequired, Dialog owner, boolean modal) {
        super(owner, modal);
        this.ssExe = ssExe;
        this.userId = userId;
        this.password = password;
        this.authRequired = (new Boolean(authRequired)).booleanValue();
        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace(vcs.log);
        }
    }

    public WorkFileMappingDialog(String ssExe, String userId, String password, String authRequired, Dialog owner, String title, boolean modal) {
        super(owner, title, modal);
        this.ssExe = ssExe;
        this.userId = userId;
        this.password = password;
        this.authRequired = (new Boolean(authRequired)).booleanValue();
        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace(vcs.log);
        }
    }

    public WorkFileMappingDialog(String ssExe, String userId, String password, String authRequired, Frame owner) {
        super(owner);
        this.ssExe = ssExe;
        this.userId = userId;
        this.password = password;
        this.authRequired = (new Boolean(authRequired)).booleanValue();
        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace(vcs.log);
        }
    }

    public WorkFileMappingDialog(String ssExe, String userId, String password, String authRequired, Frame owner, boolean modal) {
        super(owner, modal);
        this.ssExe = ssExe;
        this.userId = userId;
        this.password = password;
        this.authRequired = (new Boolean(authRequired)).booleanValue();
        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace(vcs.log);
        }
    }

    public WorkFileMappingDialog(String ssExe, String userId, String password, String authRequired, Frame owner, String title) {
        super(owner, title);
        this.ssExe = ssExe;
        this.userId = userId;
        this.password = password;
        this.authRequired = (new Boolean(authRequired)).booleanValue();
        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace(vcs.log);
        }
    }

    public WorkFileMappingDialog(String ssExe, String userId, String password, String authRequired, Frame owner, String title, boolean modal) {
        super(owner, title, modal);
        this.ssExe = ssExe;
        this.userId = userId;
        this.password = password;
        this.authRequired = (new Boolean(authRequired)).booleanValue();
        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace(vcs.log);
        }
    }

    private void jbInit() throws Exception {
            this.pnlDirectoryBrowser = new DirectoryBrowserPanel();
            this.pnlProjectBrowser = new SourceSafeProjectBrowserPanel(ssExe, userId, password, authRequired);
            this.getContentPane().setLayout(xYLayout1);
            xYLayout1.setWidth(677);
            xYLayout1.setHeight(441);
            pnlProject.setLayout(borderLayout1);
            pnlProject.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"Source Safe Project"));
            pnlWorkFile.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"Working Directory"));
            pnlWorkFile.setLayout(borderLayout2);
            btnMap.setActionCommand("btnMap");
            btnMap.setText("Map");
            btnCancel.setActionCommand("btnCancel");
            btnCancel.setText("Cancel");
            lblInstructions.setText("* Right-click on a project to add a sub-project below it.");
            scrollPaneSourceSafeProject.setBorder(null);
            this.getContentPane().add(pnlProject, new XYConstraints(14, 34, 285, 371));
            pnlProject.add(scrollPaneSourceSafeProject, BorderLayout.CENTER);
            scrollPaneSourceSafeProject.getViewport().add(pnlProjectBrowser, null);
            scrollPaneWorkingDirectory.setBorder(null);
            this.getContentPane().add(pnlWorkFile, new XYConstraints(377, 34, 285, 371));
            pnlWorkFile.add(scrollPaneWorkingDirectory, BorderLayout.CENTER);
            scrollPaneWorkingDirectory.getViewport().add(pnlDirectoryBrowser, null);
            this.getContentPane().add(btnCancel, new XYConstraints(301, 225, -1, -1));
            this.getContentPane().add(btnMap, new XYConstraints(301, 175, 73, -1));
            this.getContentPane().add(lblInstructions, new XYConstraints(14, 11, 311, -1));
    }

    public String getProjectMapping() {
        return pnlProjectBrowser.getSelectedProject();
    }

    public String getWorkingDirectoryMapping() {
        return pnlDirectoryBrowser.getSelectedDirectory();
    }

    public void refreshSourceSafeProjectView() {
        this.pnlProjectBrowser.refreshTreeProjects();
    }
}
